xlsx-1.1.4: Simple and incomplete Excel file parser/writer

Safe Haskell | None
Language | Haskell2010

Codec.Xlsx.Types.Drawing

Synopsis

- data FileInfo = FileInfo {
  - _fiFilename :: FilePath
  - _fiContentType :: Text
  - _fiContents :: ByteString
  }
- data Marker = Marker {
  - _mrkCol :: Int
  - _mrkColOff :: Coordinate
  - _mrkRow :: Int
  - _mrkRowOff :: Coordinate
  }
- unqMarker :: (Int, Int) -> (Int, Int) -> Marker
- data EditAs
  - = EditAsTwoCell
  - | EditAsOneCell
  - | EditAsAbsolute
- data Anchoring
  - = AbsoluteAnchor {
    - absaPos :: Point2D
    - absaExt :: PositiveSize2D
    }
  - | OneCellAnchor {
    - onecaFrom :: Marker
    - onecaExt :: PositiveSize2D
    }
  - | TwoCellAnchor {
    - tcaFrom :: Marker
    - tcaTo :: Marker
    - tcaEditAs :: EditAs
    }
- data DrawingObject p g
  - = Picture {
    - _picMacro :: Maybe Text
    - _picPublished :: Bool
    - _picNonVisual :: PicNonVisual
    - _picBlipFill :: BlipFillProperties p
    - _picShapeProperties :: ShapeProperties
    }
  - | Graphic {
    - _grNonVisual :: GraphNonVisual
    - _grChartSpace :: g
    - _grTransform :: Transform2D
    }
- picture :: DrawingElementId -> FileInfo -> DrawingObject FileInfo c
- extractPictures :: Drawing -> [(Anchoring, FileInfo)]
- data ClientData = ClientData {
  - _cldLcksWithSheet :: Bool
  - _cldPrintsWithSheet :: Bool
  }
- data PicNonVisual = PicNonVisual {
  - _pnvDrawingProps :: NonVisualDrawingProperties
  }
- data GraphNonVisual = GraphNonVisual {
  - _gnvDrawingProps :: NonVisualDrawingProperties
  }
- newtype DrawingElementId = DrawingElementId {
  - unDrawingElementId :: Int
  }
- data NonVisualDrawingProperties = NonVisualDrawingProperties {
  - _nvdpId :: DrawingElementId
  - _nvdpName :: Text
  - _nvdpDescription :: Maybe Text
  - _nvdpHidden :: Bool
  - _nvdpTitle :: Maybe Text
  }
- data BlipFillProperties a = BlipFillProperties {
  - _bfpImageInfo :: Maybe a
  - _bfpFillMode :: Maybe FillMode
  }
- data FillMode
  - = FillTile
  - | FillStretch
- data Anchor p g = Anchor {
  - _anchAnchoring :: Anchoring
  - _anchObject :: DrawingObject p g
  - _anchClientData :: ClientData
  }
- data GenericDrawing p g = Drawing {
  - _xdrAnchors :: [Anchor p g]
  }
- type Drawing = GenericDrawing FileInfo ChartSpace
- type UnresolvedDrawing = GenericDrawing RefId RefId
- anchAnchoring :: forall p g f. Functor f => (Anchoring -> f Anchoring) -> Anchor p g -> f (Anchor p g)
- anchClientData :: forall p g f. Functor f => (ClientData -> f ClientData) -> Anchor p g -> f (Anchor p g)
- anchObject :: forall p1 g1 p2 g2 f. Functor f => (DrawingObject p1 g1 -> f (DrawingObject p2 g2)) -> Anchor p1 g1 -> f (Anchor p2 g2)
- grChartSpace :: forall p g1 g2 f. Applicative f => (g1 -> f g2) -> DrawingObject p g1 -> f (DrawingObject p g2)
- grNonVisual :: forall p g f. Applicative f => (GraphNonVisual -> f GraphNonVisual) -> DrawingObject p g -> f (DrawingObject p g)
- grTransform :: forall p g f. Applicative f => (Transform2D -> f Transform2D) -> DrawingObject p g -> f (DrawingObject p g)
- picBlipFill :: forall p1 g p2 f. Applicative f => (BlipFillProperties p1 -> f (BlipFillProperties p2)) -> DrawingObject p1 g -> f (DrawingObject p2 g)
- picMacro :: forall p g f. Applicative f => (Maybe Text -> f (Maybe Text)) -> DrawingObject p g -> f (DrawingObject p g)
- picNonVisual :: forall p g f. Applicative f => (PicNonVisual -> f PicNonVisual) -> DrawingObject p g -> f (DrawingObject p g)
- picPublished :: forall p g f. Applicative f => (Bool -> f Bool) -> DrawingObject p g -> f (DrawingObject p g)
- picShapeProperties :: forall p g f. Applicative f => (ShapeProperties -> f ShapeProperties) -> DrawingObject p g -> f (DrawingObject p g)
- bfpFillMode :: forall a f. Functor f => (Maybe FillMode -> f (Maybe FillMode)) -> BlipFillProperties a -> f (BlipFillProperties a)
- bfpImageInfo :: forall a1 a2 f. Functor f => (Maybe a1 -> f (Maybe a2)) -> BlipFillProperties a1 -> f (BlipFillProperties a2)
- xdrAnchors :: forall p1 g1 p2 g2 p3 f. (Profunctor p3, Functor f) => p3 [Anchor p1 g1] (f [Anchor p2 g2]) -> p3 (GenericDrawing p1 g1) (f (GenericDrawing p2 g2))
- simpleAnchorXY :: (Int, Int) -> PositiveSize2D -> DrawingObject p g -> Anchor p g
- anchoringFromNode :: Node -> [Anchoring]
- drawingObjectFromNode :: Node -> [DrawingObject RefId RefId]
- fillModeFromNode :: Node -> [FillMode]
- anchorToElement :: Anchor RefId RefId -> Element
- anchoringToElement :: Anchoring -> Element
- drawingObjToElement :: DrawingObject RefId RefId -> Element
- fillModeToElement :: FillMode -> Element
- xdr :: Text -> Name
- xlDrawingNs :: Text

# Documentation

data FileInfo Source #

information about image file as a par of a drawing

Constructors

FileInfo |

Fields

- _fiFilename :: FilePath

  image filename, images are assumed to be stored under path "xl/media/"

- _fiContentType :: Text

  image content type, ECMA-376 advises to use "image/png" or "image/jpeg" if interoperability is wanted

- _fiContents :: ByteString

  image file contents

#### Instances

Instances details

NFData FileInfo Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods rnf :: FileInfo -> () Source #
Generic FileInfo Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

Associated Types

type Rep FileInfo |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep FileInfo = D1 ('MetaData "FileInfo" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "FileInfo" 'PrefixI 'True) (S1 ('MetaSel ('Just "_fiFilename") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 FilePath) :*: (S1 ('MetaSel ('Just "_fiContentType") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Just "_fiContents") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ByteString))))

Methods

from :: FileInfo -> Rep FileInfo x Source #

to :: Rep FileInfo x -> FileInfo Source #

Show FileInfo Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods showsPrec :: Int -> FileInfo -> ShowS Source # show :: FileInfo -> String Source # showList :: [FileInfo] -> ShowS Source #
Eq FileInfo Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods (==) :: FileInfo -> FileInfo -> Bool Source # (/=) :: FileInfo -> FileInfo -> Bool Source #
type Rep FileInfo Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep FileInfo = D1 ('MetaData "FileInfo" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "FileInfo" 'PrefixI 'True) (S1 ('MetaSel ('Just "_fiFilename") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 FilePath) :*: (S1 ('MetaSel ('Just "_fiContentType") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Just "_fiContents") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ByteString))))

data Marker Source #

Constructors

Marker |

Fields

- _mrkCol :: Int
- _mrkColOff :: Coordinate
- _mrkRow :: Int
- _mrkRowOff :: Coordinate

#### Instances

Instances details

NFData Marker Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods rnf :: Marker -> () Source #
Generic Marker Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

Associated Types

type Rep Marker |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep Marker = D1 ('MetaData "Marker" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "Marker" 'PrefixI 'True) ((S1 ('MetaSel ('Just "_mrkCol") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Int) :*: S1 ('MetaSel ('Just "_mrkColOff") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Coordinate)) :*: (S1 ('MetaSel ('Just "_mrkRow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Int) :*: S1 ('MetaSel ('Just "_mrkRowOff") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Coordinate))))

Methods

from :: Marker -> Rep Marker x Source #

to :: Rep Marker x -> Marker Source #

Show Marker Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods showsPrec :: Int -> Marker -> ShowS Source # show :: Marker -> String Source # showList :: [Marker] -> ShowS Source #
Eq Marker Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods (==) :: Marker -> Marker -> Bool Source # (/=) :: Marker -> Marker -> Bool Source #
FromCursor Marker Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods fromCursor :: Cursor -> [Marker] Source #
ToElement Marker Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods toElement :: Name -> Marker -> Element Source #
type Rep Marker Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep Marker = D1 ('MetaData "Marker" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "Marker" 'PrefixI 'True) ((S1 ('MetaSel ('Just "_mrkCol") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Int) :*: S1 ('MetaSel ('Just "_mrkColOff") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Coordinate)) :*: (S1 ('MetaSel ('Just "_mrkRow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Int) :*: S1 ('MetaSel ('Just "_mrkRowOff") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Coordinate))))

unqMarker :: (Int, Int) -> (Int, Int) -> Marker Source #

data EditAs Source #

Constructors

EditAsTwoCell |
EditAsOneCell |
EditAsAbsolute |

#### Instances

Instances details

NFData EditAs Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods rnf :: EditAs -> () Source #
Generic EditAs Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

Associated Types

type Rep EditAs |
Instance details Defined in Codec.Xlsx.Types.Drawing type Rep EditAs = D1 ('MetaData "EditAs" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "EditAsTwoCell" 'PrefixI 'False) (U1 :: Type -> Type) :+: (C1 ('MetaCons "EditAsOneCell" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "EditAsAbsolute" 'PrefixI 'False) (U1 :: Type -> Type)))

Methods

from :: EditAs -> Rep EditAs x Source #

to :: Rep EditAs x -> EditAs Source #

Show EditAs Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods showsPrec :: Int -> EditAs -> ShowS Source # show :: EditAs -> String Source # showList :: [EditAs] -> ShowS Source #
Eq EditAs Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods (==) :: EditAs -> EditAs -> Bool Source # (/=) :: EditAs -> EditAs -> Bool Source #
FromAttrVal EditAs Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods fromAttrVal :: Reader EditAs Source #
ToAttrVal EditAs Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods toAttrVal :: EditAs -> Text Source #
type Rep EditAs Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing type Rep EditAs = D1 ('MetaData "EditAs" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "EditAsTwoCell" 'PrefixI 'False) (U1 :: Type -> Type) :+: (C1 ('MetaCons "EditAsOneCell" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "EditAsAbsolute" 'PrefixI 'False) (U1 :: Type -> Type)))

data Anchoring Source #

Constructors

AbsoluteAnchor |

Fields

- absaPos :: Point2D
- absaExt :: PositiveSize2D

OneCellAnchor |

Fields

- onecaFrom :: Marker
- onecaExt :: PositiveSize2D

TwoCellAnchor |

Fields

- tcaFrom :: Marker
- tcaTo :: Marker
- tcaEditAs :: EditAs

#### Instances

Instances details

NFData Anchoring Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods rnf :: Anchoring -> () Source #
Generic Anchoring Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

Associated Types

type Rep Anchoring |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep Anchoring = D1 ('MetaData "Anchoring" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "AbsoluteAnchor" 'PrefixI 'True) (S1 ('MetaSel ('Just "absaPos") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Point2D) :*: S1 ('MetaSel ('Just "absaExt") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 PositiveSize2D)) :+: (C1 ('MetaCons "OneCellAnchor" 'PrefixI 'True) (S1 ('MetaSel ('Just "onecaFrom") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Marker) :*: S1 ('MetaSel ('Just "onecaExt") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 PositiveSize2D)) :+: C1 ('MetaCons "TwoCellAnchor" 'PrefixI 'True) (S1 ('MetaSel ('Just "tcaFrom") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Marker) :*: (S1 ('MetaSel ('Just "tcaTo") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Marker) :*: S1 ('MetaSel ('Just "tcaEditAs") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 EditAs)))))

Methods

from :: Anchoring -> Rep Anchoring x Source #

to :: Rep Anchoring x -> Anchoring Source #

Show Anchoring Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods showsPrec :: Int -> Anchoring -> ShowS Source # show :: Anchoring -> String Source # showList :: [Anchoring] -> ShowS Source #
Eq Anchoring Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods (==) :: Anchoring -> Anchoring -> Bool Source # (/=) :: Anchoring -> Anchoring -> Bool Source #
FromCursor Anchoring Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods fromCursor :: Cursor -> [Anchoring] Source #
type Rep Anchoring Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep Anchoring = D1 ('MetaData "Anchoring" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "AbsoluteAnchor" 'PrefixI 'True) (S1 ('MetaSel ('Just "absaPos") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Point2D) :*: S1 ('MetaSel ('Just "absaExt") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 PositiveSize2D)) :+: (C1 ('MetaCons "OneCellAnchor" 'PrefixI 'True) (S1 ('MetaSel ('Just "onecaFrom") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Marker) :*: S1 ('MetaSel ('Just "onecaExt") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 PositiveSize2D)) :+: C1 ('MetaCons "TwoCellAnchor" 'PrefixI 'True) (S1 ('MetaSel ('Just "tcaFrom") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Marker) :*: (S1 ('MetaSel ('Just "tcaTo") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Marker) :*: S1 ('MetaSel ('Just "tcaEditAs") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 EditAs)))))

data DrawingObject p g Source #

Constructors

Picture |

Fields

- _picMacro :: Maybe Text
- _picPublished :: Bool
- _picNonVisual :: PicNonVisual
- _picBlipFill :: BlipFillProperties p
- _picShapeProperties :: ShapeProperties

Graphic |

Fields

- _grNonVisual :: GraphNonVisual
- _grChartSpace :: g
- _grTransform :: Transform2D

#### Instances

Instances details

(NFData p, NFData g) => NFData (DrawingObject p g) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods rnf :: DrawingObject p g -> () Source #
Generic (DrawingObject p g) Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

Associated Types

type Rep (DrawingObject p g) |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep (DrawingObject p g) = D1 ('MetaData "DrawingObject" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "Picture" 'PrefixI 'True) ((S1 ('MetaSel ('Just "_picMacro") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text)) :*: S1 ('MetaSel ('Just "_picPublished") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool)) :*: (S1 ('MetaSel ('Just "_picNonVisual") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 PicNonVisual) :*: (S1 ('MetaSel ('Just "_picBlipFill") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (BlipFillProperties p)) :*: S1 ('MetaSel ('Just "_picShapeProperties") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ShapeProperties)))) :+: C1 ('MetaCons "Graphic" 'PrefixI 'True) (S1 ('MetaSel ('Just "_grNonVisual") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 GraphNonVisual) :*: (S1 ('MetaSel ('Just "_grChartSpace") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 g) :*: S1 ('MetaSel ('Just "_grTransform") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Transform2D))))

Methods

from :: DrawingObject p g -> Rep (DrawingObject p g) x Source #

to :: Rep (DrawingObject p g) x -> DrawingObject p g Source #

(Show p, Show g) => Show (DrawingObject p g) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods showsPrec :: Int -> DrawingObject p g -> ShowS Source # show :: DrawingObject p g -> String Source # showList :: [DrawingObject p g] -> ShowS Source #
(Eq p, Eq g) => Eq (DrawingObject p g) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods (==) :: DrawingObject p g -> DrawingObject p g -> Bool Source # (/=) :: DrawingObject p g -> DrawingObject p g -> Bool Source #
FromCursor (DrawingObject RefId RefId) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods fromCursor :: Cursor -> [DrawingObject RefId RefId] Source #
type Rep (DrawingObject p g) Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep (DrawingObject p g) = D1 ('MetaData "DrawingObject" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "Picture" 'PrefixI 'True) ((S1 ('MetaSel ('Just "_picMacro") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text)) :*: S1 ('MetaSel ('Just "_picPublished") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool)) :*: (S1 ('MetaSel ('Just "_picNonVisual") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 PicNonVisual) :*: (S1 ('MetaSel ('Just "_picBlipFill") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (BlipFillProperties p)) :*: S1 ('MetaSel ('Just "_picShapeProperties") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ShapeProperties)))) :+: C1 ('MetaCons "Graphic" 'PrefixI 'True) (S1 ('MetaSel ('Just "_grNonVisual") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 GraphNonVisual) :*: (S1 ('MetaSel ('Just "_grChartSpace") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 g) :*: S1 ('MetaSel ('Just "_grTransform") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Transform2D))))

picture :: DrawingElementId -> FileInfo -> DrawingObject FileInfo c Source #

basic function to create picture drawing object

Note: specification says that drawing element ids need to be unique within 1 document, otherwise /...document shall be considered non-conformant/.

extractPictures :: Drawing -> [(Anchoring, FileInfo)] Source #

helper to retrive information about all picture files in particular drawing alongside with their anchorings (i.e. sizes and positions)

data ClientData Source #

This element is used to set certain properties related to a drawing element on the client spreadsheet application.

see 20.5.2.3 "clientData (Client Data)" (p. 3156)

Constructors

ClientData |

Fields

- _cldLcksWithSheet :: Bool

  This attribute indicates whether to disable selection on drawing elements when the sheet is protected.

- _cldPrintsWithSheet :: Bool

  This attribute indicates whether to print drawing elements when printing the sheet.

#### Instances

Instances details

Default ClientData Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods def :: ClientData Source #
NFData ClientData Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods rnf :: ClientData -> () Source #
Generic ClientData Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

Associated Types

type Rep ClientData |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep ClientData = D1 ('MetaData "ClientData" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "ClientData" 'PrefixI 'True) (S1 ('MetaSel ('Just "_cldLcksWithSheet") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool) :*: S1 ('MetaSel ('Just "_cldPrintsWithSheet") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool)))

Methods

from :: ClientData -> Rep ClientData x Source #

to :: Rep ClientData x -> ClientData Source #

Show ClientData Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods showsPrec :: Int -> ClientData -> ShowS Source # show :: ClientData -> String Source # showList :: [ClientData] -> ShowS Source #
Eq ClientData Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods (==) :: ClientData -> ClientData -> Bool Source # (/=) :: ClientData -> ClientData -> Bool Source #
FromCursor ClientData Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods fromCursor :: Cursor -> [ClientData] Source #
ToElement ClientData Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods toElement :: Name -> ClientData -> Element Source #
type Rep ClientData Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep ClientData = D1 ('MetaData "ClientData" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "ClientData" 'PrefixI 'True) (S1 ('MetaSel ('Just "_cldLcksWithSheet") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool) :*: S1 ('MetaSel ('Just "_cldPrintsWithSheet") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool)))

data PicNonVisual Source #

Constructors

PicNonVisual |

Fields

- _pnvDrawingProps :: NonVisualDrawingProperties

#### Instances

Instances details

NFData PicNonVisual Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods rnf :: PicNonVisual -> () Source #
Generic PicNonVisual Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

Associated Types

type Rep PicNonVisual |
Instance details Defined in Codec.Xlsx.Types.Drawing type Rep PicNonVisual = D1 ('MetaData "PicNonVisual" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "PicNonVisual" 'PrefixI 'True) (S1 ('MetaSel ('Just "_pnvDrawingProps") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 NonVisualDrawingProperties)))

Methods

from :: PicNonVisual -> Rep PicNonVisual x Source #

to :: Rep PicNonVisual x -> PicNonVisual Source #

Show PicNonVisual Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods showsPrec :: Int -> PicNonVisual -> ShowS Source # show :: PicNonVisual -> String Source # showList :: [PicNonVisual] -> ShowS Source #
Eq PicNonVisual Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods (==) :: PicNonVisual -> PicNonVisual -> Bool Source # (/=) :: PicNonVisual -> PicNonVisual -> Bool Source #
FromCursor PicNonVisual Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods fromCursor :: Cursor -> [PicNonVisual] Source #
ToElement PicNonVisual Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods toElement :: Name -> PicNonVisual -> Element Source #
type Rep PicNonVisual Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing type Rep PicNonVisual = D1 ('MetaData "PicNonVisual" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "PicNonVisual" 'PrefixI 'True) (S1 ('MetaSel ('Just "_pnvDrawingProps") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 NonVisualDrawingProperties)))

data GraphNonVisual Source #

Constructors

GraphNonVisual |

Fields

- _gnvDrawingProps :: NonVisualDrawingProperties

#### Instances

Instances details

NFData GraphNonVisual Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods rnf :: GraphNonVisual -> () Source #
Generic GraphNonVisual Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

Associated Types

type Rep GraphNonVisual |
Instance details Defined in Codec.Xlsx.Types.Drawing type Rep GraphNonVisual = D1 ('MetaData "GraphNonVisual" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "GraphNonVisual" 'PrefixI 'True) (S1 ('MetaSel ('Just "_gnvDrawingProps") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 NonVisualDrawingProperties)))

Methods

from :: GraphNonVisual -> Rep GraphNonVisual x Source #

to :: Rep GraphNonVisual x -> GraphNonVisual Source #

Show GraphNonVisual Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods showsPrec :: Int -> GraphNonVisual -> ShowS Source # show :: GraphNonVisual -> String Source # showList :: [GraphNonVisual] -> ShowS Source #
Eq GraphNonVisual Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods (==) :: GraphNonVisual -> GraphNonVisual -> Bool Source # (/=) :: GraphNonVisual -> GraphNonVisual -> Bool Source #
FromCursor GraphNonVisual Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods fromCursor :: Cursor -> [GraphNonVisual] Source #
ToElement GraphNonVisual Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods toElement :: Name -> GraphNonVisual -> Element Source #
type Rep GraphNonVisual Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing type Rep GraphNonVisual = D1 ('MetaData "GraphNonVisual" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "GraphNonVisual" 'PrefixI 'True) (S1 ('MetaSel ('Just "_gnvDrawingProps") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 NonVisualDrawingProperties)))

newtype DrawingElementId Source #

Constructors

DrawingElementId |

Fields

- unDrawingElementId :: Int

#### Instances

Instances details

NFData DrawingElementId Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods rnf :: DrawingElementId -> () Source #
Generic DrawingElementId Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

Associated Types

type Rep DrawingElementId |
Instance details Defined in Codec.Xlsx.Types.Drawing type Rep DrawingElementId = D1 ('MetaData "DrawingElementId" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'True) (C1 ('MetaCons "DrawingElementId" 'PrefixI 'True) (S1 ('MetaSel ('Just "unDrawingElementId") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Int)))

Methods

from :: DrawingElementId -> Rep DrawingElementId x Source #

to :: Rep DrawingElementId x -> DrawingElementId Source #

Show DrawingElementId Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods showsPrec :: Int -> DrawingElementId -> ShowS Source # show :: DrawingElementId -> String Source # showList :: [DrawingElementId] -> ShowS Source #
Eq DrawingElementId Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods (==) :: DrawingElementId -> DrawingElementId -> Bool Source # (/=) :: DrawingElementId -> DrawingElementId -> Bool Source #
FromAttrVal DrawingElementId Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods fromAttrVal :: Reader DrawingElementId Source #
ToAttrVal DrawingElementId Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods toAttrVal :: DrawingElementId -> Text Source #
type Rep DrawingElementId Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing type Rep DrawingElementId = D1 ('MetaData "DrawingElementId" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'True) (C1 ('MetaCons "DrawingElementId" 'PrefixI 'True) (S1 ('MetaSel ('Just "unDrawingElementId") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Int)))

data NonVisualDrawingProperties Source #

Constructors

NonVisualDrawingProperties |

Fields

- _nvdpId :: DrawingElementId

  Specifies a unique identifier for the current DrawingML object within the current

  TODO: make ids internal and consistent by construction

- _nvdpName :: Text

  Specifies the name of the object. Typically, this is used to store the original file name of a picture object.

- _nvdpDescription :: Maybe Text

  Alternative Text for Object

- _nvdpHidden :: Bool
- _nvdpTitle :: Maybe Text

#### Instances

Instances details

NFData NonVisualDrawingProperties Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods rnf :: NonVisualDrawingProperties -> () Source #
Generic NonVisualDrawingProperties Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

Associated Types

type Rep NonVisualDrawingProperties |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep NonVisualDrawingProperties = D1 ('MetaData "NonVisualDrawingProperties" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "NonVisualDrawingProperties" 'PrefixI 'True) ((S1 ('MetaSel ('Just "_nvdpId") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 DrawingElementId) :*: S1 ('MetaSel ('Just "_nvdpName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)) :*: (S1 ('MetaSel ('Just "_nvdpDescription") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text)) :*: (S1 ('MetaSel ('Just "_nvdpHidden") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool) :*: S1 ('MetaSel ('Just "_nvdpTitle") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text))))))

Methods

from :: NonVisualDrawingProperties -> Rep NonVisualDrawingProperties x Source #

to :: Rep NonVisualDrawingProperties x -> NonVisualDrawingProperties Source #

Show NonVisualDrawingProperties Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods showsPrec :: Int -> NonVisualDrawingProperties -> ShowS Source # show :: NonVisualDrawingProperties -> String Source # showList :: [NonVisualDrawingProperties] -> ShowS Source #
Eq NonVisualDrawingProperties Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods (==) :: NonVisualDrawingProperties -> NonVisualDrawingProperties -> Bool Source # (/=) :: NonVisualDrawingProperties -> NonVisualDrawingProperties -> Bool Source #
FromCursor NonVisualDrawingProperties Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods fromCursor :: Cursor -> [NonVisualDrawingProperties] Source #
ToElement NonVisualDrawingProperties Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods toElement :: Name -> NonVisualDrawingProperties -> Element Source #
type Rep NonVisualDrawingProperties Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep NonVisualDrawingProperties = D1 ('MetaData "NonVisualDrawingProperties" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "NonVisualDrawingProperties" 'PrefixI 'True) ((S1 ('MetaSel ('Just "_nvdpId") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 DrawingElementId) :*: S1 ('MetaSel ('Just "_nvdpName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)) :*: (S1 ('MetaSel ('Just "_nvdpDescription") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text)) :*: (S1 ('MetaSel ('Just "_nvdpHidden") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool) :*: S1 ('MetaSel ('Just "_nvdpTitle") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text))))))

data BlipFillProperties a Source #

Constructors

BlipFillProperties |

Fields

- _bfpImageInfo :: Maybe a
- _bfpFillMode :: Maybe FillMode

#### Instances

Instances details

NFData a => NFData (BlipFillProperties a) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods rnf :: BlipFillProperties a -> () Source #
Generic (BlipFillProperties a) Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

Associated Types

type Rep (BlipFillProperties a) |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep (BlipFillProperties a) = D1 ('MetaData "BlipFillProperties" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "BlipFillProperties" 'PrefixI 'True) (S1 ('MetaSel ('Just "_bfpImageInfo") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe a)) :*: S1 ('MetaSel ('Just "_bfpFillMode") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe FillMode))))

Methods

from :: BlipFillProperties a -> Rep (BlipFillProperties a) x Source #

to :: Rep (BlipFillProperties a) x -> BlipFillProperties a Source #

Show a => Show (BlipFillProperties a) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods showsPrec :: Int -> BlipFillProperties a -> ShowS Source # show :: BlipFillProperties a -> String Source # showList :: [BlipFillProperties a] -> ShowS Source #
Eq a => Eq (BlipFillProperties a) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods (==) :: BlipFillProperties a -> BlipFillProperties a -> Bool Source # (/=) :: BlipFillProperties a -> BlipFillProperties a -> Bool Source #
FromCursor (BlipFillProperties RefId) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods fromCursor :: Cursor -> [BlipFillProperties RefId] Source #
ToElement (BlipFillProperties RefId) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods toElement :: Name -> BlipFillProperties RefId -> Element Source #
type Rep (BlipFillProperties a) Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep (BlipFillProperties a) = D1 ('MetaData "BlipFillProperties" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "BlipFillProperties" 'PrefixI 'True) (S1 ('MetaSel ('Just "_bfpImageInfo") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe a)) :*: S1 ('MetaSel ('Just "_bfpFillMode") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe FillMode))))

data FillMode Source #

Constructors

FillTile |
FillStretch |

#### Instances

Instances details

NFData FillMode Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods rnf :: FillMode -> () Source #
Generic FillMode Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

Associated Types

type Rep FillMode |
Instance details Defined in Codec.Xlsx.Types.Drawing type Rep FillMode = D1 ('MetaData "FillMode" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "FillTile" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "FillStretch" 'PrefixI 'False) (U1 :: Type -> Type))

Methods

from :: FillMode -> Rep FillMode x Source #

to :: Rep FillMode x -> FillMode Source #

Show FillMode Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods showsPrec :: Int -> FillMode -> ShowS Source # show :: FillMode -> String Source # showList :: [FillMode] -> ShowS Source #
Eq FillMode Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods (==) :: FillMode -> FillMode -> Bool Source # (/=) :: FillMode -> FillMode -> Bool Source #
FromCursor FillMode Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods fromCursor :: Cursor -> [FillMode] Source #
type Rep FillMode Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing type Rep FillMode = D1 ('MetaData "FillMode" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "FillTile" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "FillStretch" 'PrefixI 'False) (U1 :: Type -> Type))

data Anchor p g Source #

Constructors

Anchor |

Fields

- _anchAnchoring :: Anchoring
- _anchObject :: DrawingObject p g
- _anchClientData :: ClientData

#### Instances

Instances details

(NFData p, NFData g) => NFData (Anchor p g) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods rnf :: Anchor p g -> () Source #
Generic (Anchor p g) Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

Associated Types

type Rep (Anchor p g) |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep (Anchor p g) = D1 ('MetaData "Anchor" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "Anchor" 'PrefixI 'True) (S1 ('MetaSel ('Just "_anchAnchoring") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Anchoring) :*: (S1 ('MetaSel ('Just "_anchObject") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (DrawingObject p g)) :*: S1 ('MetaSel ('Just "_anchClientData") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ClientData))))

Methods

from :: Anchor p g -> Rep (Anchor p g) x Source #

to :: Rep (Anchor p g) x -> Anchor p g Source #

(Show p, Show g) => Show (Anchor p g) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods showsPrec :: Int -> Anchor p g -> ShowS Source # show :: Anchor p g -> String Source # showList :: [Anchor p g] -> ShowS Source #
(Eq p, Eq g) => Eq (Anchor p g) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods (==) :: Anchor p g -> Anchor p g -> Bool Source # (/=) :: Anchor p g -> Anchor p g -> Bool Source #
FromCursor (Anchor RefId RefId) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods fromCursor :: Cursor -> [Anchor RefId RefId] Source #
type Rep (Anchor p g) Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

type Rep (Anchor p g) = D1 ('MetaData "Anchor" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "Anchor" 'PrefixI 'True) (S1 ('MetaSel ('Just "_anchAnchoring") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Anchoring) :*: (S1 ('MetaSel ('Just "_anchObject") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (DrawingObject p g)) :*: S1 ('MetaSel ('Just "_anchClientData") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ClientData))))

data GenericDrawing p g Source #

Constructors

Drawing |

Fields

- _xdrAnchors :: [Anchor p g]

#### Instances

Instances details

FromCursor UnresolvedDrawing Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods fromCursor :: Cursor -> [UnresolvedDrawing] Source #
ToDocument UnresolvedDrawing Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods toDocument :: UnresolvedDrawing -> Document Source #
ToElement UnresolvedDrawing Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods toElement :: Name -> UnresolvedDrawing -> Element Source #
(NFData p, NFData g) => NFData (GenericDrawing p g) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods rnf :: GenericDrawing p g -> () Source #
Generic (GenericDrawing p g) Source # |

Instance details

Defined in Codec.Xlsx.Types.Drawing

Associated Types

type Rep (GenericDrawing p g) |
Instance details Defined in Codec.Xlsx.Types.Drawing type Rep (GenericDrawing p g) = D1 ('MetaData "GenericDrawing" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "Drawing" 'PrefixI 'True) (S1 ('MetaSel ('Just "_xdrAnchors") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [Anchor p g])))

Methods

from :: GenericDrawing p g -> Rep (GenericDrawing p g) x Source #

to :: Rep (GenericDrawing p g) x -> GenericDrawing p g Source #

(Show p, Show g) => Show (GenericDrawing p g) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods showsPrec :: Int -> GenericDrawing p g -> ShowS Source # show :: GenericDrawing p g -> String Source # showList :: [GenericDrawing p g] -> ShowS Source #
(Eq p, Eq g) => Eq (GenericDrawing p g) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing Methods (==) :: GenericDrawing p g -> GenericDrawing p g -> Bool Source # (/=) :: GenericDrawing p g -> GenericDrawing p g -> Bool Source #
type Rep (GenericDrawing p g) Source # |
Instance details Defined in Codec.Xlsx.Types.Drawing type Rep (GenericDrawing p g) = D1 ('MetaData "GenericDrawing" "Codec.Xlsx.Types.Drawing" "xlsx-1.1.4-G0KawmQS4mL8oRGRTaTy8Y" 'False) (C1 ('MetaCons "Drawing" 'PrefixI 'True) (S1 ('MetaSel ('Just "_xdrAnchors") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [Anchor p g])))

type Drawing = GenericDrawing FileInfo ChartSpace Source #

type UnresolvedDrawing = GenericDrawing RefId RefId Source #

anchAnchoring :: forall p g f. Functor f => (Anchoring -> f Anchoring) -> Anchor p g -> f (Anchor p g) Source #

anchClientData :: forall p g f. Functor f => (ClientData -> f ClientData) -> Anchor p g -> f (Anchor p g) Source #

anchObject :: forall p1 g1 p2 g2 f. Functor f => (DrawingObject p1 g1 -> f (DrawingObject p2 g2)) -> Anchor p1 g1 -> f (Anchor p2 g2) Source #

grChartSpace :: forall p g1 g2 f. Applicative f => (g1 -> f g2) -> DrawingObject p g1 -> f (DrawingObject p g2) Source #

grNonVisual :: forall p g f. Applicative f => (GraphNonVisual -> f GraphNonVisual) -> DrawingObject p g -> f (DrawingObject p g) Source #

grTransform :: forall p g f. Applicative f => (Transform2D -> f Transform2D) -> DrawingObject p g -> f (DrawingObject p g) Source #

picBlipFill :: forall p1 g p2 f. Applicative f => (BlipFillProperties p1 -> f (BlipFillProperties p2)) -> DrawingObject p1 g -> f (DrawingObject p2 g) Source #

picMacro :: forall p g f. Applicative f => (Maybe Text -> f (Maybe Text)) -> DrawingObject p g -> f (DrawingObject p g) Source #

picNonVisual :: forall p g f. Applicative f => (PicNonVisual -> f PicNonVisual) -> DrawingObject p g -> f (DrawingObject p g) Source #

picPublished :: forall p g f. Applicative f => (Bool -> f Bool) -> DrawingObject p g -> f (DrawingObject p g) Source #

picShapeProperties :: forall p g f. Applicative f => (ShapeProperties -> f ShapeProperties) -> DrawingObject p g -> f (DrawingObject p g) Source #

bfpFillMode :: forall a f. Functor f => (Maybe FillMode -> f (Maybe FillMode)) -> BlipFillProperties a -> f (BlipFillProperties a) Source #

bfpImageInfo :: forall a1 a2 f. Functor f => (Maybe a1 -> f (Maybe a2)) -> BlipFillProperties a1 -> f (BlipFillProperties a2) Source #

xdrAnchors :: forall p1 g1 p2 g2 p3 f. (Profunctor p3, Functor f) => p3 [Anchor p1 g1] (f [Anchor p2 g2]) -> p3 (GenericDrawing p1 g1) (f (GenericDrawing p2 g2)) Source #

simpleAnchorXY Source #

Arguments

:: (Int, Int) | x+y coordinates of a cell used as top left anchoring corner
-> PositiveSize2D | size of drawing object to be anchored
-> DrawingObject p g |
-> Anchor p g |

simple drawing object anchoring using one cell as a top lelft corner and dimensions of that object

anchoringFromNode :: Node -> [Anchoring] Source #

drawingObjectFromNode :: Node -> [DrawingObject RefId RefId] Source #

fillModeFromNode :: Node -> [FillMode] Source #

anchorToElement :: Anchor RefId RefId -> Element Source #

anchoringToElement :: Anchoring -> Element Source #

drawingObjToElement :: DrawingObject RefId RefId -> Element Source #

fillModeToElement :: FillMode -> Element Source #

xdr :: Text -> Name Source #

Add Spreadsheet DrawingML namespace to name

xlDrawingNs :: Text Source #